declare namespace m = "http://www.w3.org/2005/10/feed-validator";

declare function local:output-message($message as node(), $color as xs:integer) as xs:string {
  $message/concat(
    "&#10;&#x1b;[",
    $color,
    "m",
    upper-case(name()),
    "&#x1b;[m at line ",
    if (backupline ne line) then backupline else line,
    ", column ",
    if (backupcolumn ne column) then backupcolumn else column,
    ": ",
    text,
    if (number(msgcount) gt 1) then concat("&#10;  Repeated ", msgcount, "times") else "",
    "&#10;  Documentation: https://validator.w3.org/feed/docs/",
    lower-case(name()),
    "/",
    type,
    ".html"
  )
};

declare function local:pluralize($value as xs:integer, $label as xs:string) as xs:string {
  concat($value, ' ', $label, if ($value ne 1) then 's' else ())
};

parse-xml(x:request(x:form(
  <form action="https://validator.w3.org/feed/check.cgi">
    <input name="output" value="soap12" />
    <input name="url" value="https://envs.net/~lucidiot/rsrsss/feed.xml" />
  </form>
))/raw)//m:feedvalidationresponse ! concat(
  "W3C feed validation results for ",
  m:uri,
  " on ",
  m:date,
  ": &#x1b;[1m&#x1b;[",
  switch (m:validity)
    case "true" return "92mVALID"
    case "false" return "91mINVALID"
    default return concat("93mUNKNOWN (", ., ")"),
  "&#x1b;[m&#10;",
  string-join((
    local:pluralize(m:errors/m:errorcount, "error"),
    local:pluralize(m:warnings/m:warningcount, "warning"),
    local:pluralize(m:informations/m:infocount, "information")
  ), ", "),
  "&#10;",
  string-join((
    m:errors/m:errorlist/error ! local:output-message(., 91),
    m:warnings/m:warninglist/warning ! local:output-message(., 93),
    m:informations/m:infolist/info ! local:output-message(., 96)
  ), "&#10;")
)
